<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

?><h2><?php print $gMenuStructure['database']['submenu']['error_log']['title']; ?> for database <?php print $aNode['name']; ?></h2>

<?php

list($ret, $aServer) = getServerById($dbh, $aNode['server_id']);


// Get actual MySQL error log directly from the database

list ($ret, $mysqli) = openDatabaseConnection($aNode['database_user'], $aNode['database_user_password'], $aNode['hostname'], $aNode['port']);

$lErrorLog = '';
if ( $ret == OK ) {
  list($ret, $lErrorLog) = getErrorLog($mysqli);
  logMessage(LOG_DEBUG, "(rc=$ret), $lErrorLog");
  closeDatabaseConnection($mysqli);
}

// If we cannot get the actual MySQL error log look into repository/configuration
if ( $lErrorLog == '' ) {
  $lErrorLog = $aNode['error_log'];
}

if ( $lErrorLog != '' ) {

  $tail_lines = 20;
  list ($ret, $output) = getTailOfFile($aServer['os_user'], $aServer['name'], $lErrorLog, $tail_lines);
  if ( $ret == OK ) {

    // Color warning and error messages
    $pattern = '/(warning)/i';
    $replacement = '<span style="color:orange; font-weight:bold;">${1}</span>';
    $output = preg_replace($pattern, $replacement, $output);

    $pattern = '/(error)/i';
    $replacement = '<span style="color:red; font-weight:bold;">${1}</span>';
    $output = preg_replace($pattern, $replacement, $output);

    ?><pre style="overflow:auto;" width="80">...<br /><?php print $output; ?></pre><?php
  }
  else {
    print "<p>Cannot read error log file $lErrorLog.</p>\n";
  }
}
else {
  print "<p>Cannot get <code>log_error</code> variable.</p>\n";
}

?>
