<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

require_once('lib/Cluster.inc');
require_once('lib/Database.inc');

// http://api.jqueryui.com/dialog/
?>

<link rel="stylesheet" href="css/jquery-ui.css" />
<script src="js/jquery.js"></script>
<script src="js/jquery-ui.js"></script>

<script>

// increase the default animation speed to exaggerate the effect
$.fx.speeds._default = 1000;

$(function() {
  $('#server_id').dialog({
    autoOpen: false
  , show: 'blind'
  });
  $('#server_id_opener').click(function() {
    $('#server_id').dialog('open');
    return false;
  });
});

$(function() {
  $('#binary_log_file').dialog({
    autoOpen: false
  , show: 'blind'
  });
  $('#binary_log_file_opener').click(function() {
    $('#binary_log_file').dialog('open');
    return false;
  });
});

</script>

<?php

// print "<pre>"; print_r($_REQUEST); print "</pre>";

list($ret, $dbh) = openRepositoryDatabase();
list($ret, $aCluster) = getClusterById($dbh, $hClusterId);
// Type 1 = Master/Slave
// list($ret, $aMasterSlaves) = getAllClusters($dbh, 1);
list($ret, $aNodes) = getNodesOfClusterById($dbh, $hClusterId);
// print "<pre>"; print_r($aNodes); print "</pre>";

?>

<h2><?php print $gMenuStructure['database']['submenu']['checks']['title']; ?> for Replication <?php print $aCluster['name']; ?></h2>

<?php
/*
<p>
<input type="button" value="Check Replication" onclick="location.href='index.php?f=test&amp;o=replication&amp;cluster_id=<?php print $hClusterId; ?>';" />
&nbsp;
<input type="button" value="Check Node" onclick="location.href='index.php?f=test&amp;o=node&amp;node_id=<?php print $hNodeId; ?>';" />
</p>
*/
?>

<h3>Master</h3>

<?php

foreach ( $aNodes as $id => $node ) {

  if ( $node['role_id'] == MASTER ) {

    // print "<pre>"; print_r($node); print "</pre>";
    ?>
    <h4><?php print $node['name']; ?></h4>
    <?php

    list($ret, $mysqli) = openDatabaseConnection($node['database_user'], $node['database_user_password'], $node['hostname'], $node['port']);
    if ( $ret != 0 ) {
      print "<p>" . $mysqli . "</p>\n";
      exit($ret);
    }

    list($ret, $aGlobalVariables) = getAllGlobalVariables($mysqli);
    // print "<pre>"; var_dump($aGlobalVariables); print "</pre>";
    list($ret, $aMasterStatus) = getShowMasterStatus($mysqli);
    // print "<pre>"; var_dump($aMasterStatus); print "</pre>";
    // list($ret, $aSlaveStatus) = getShowSlaveStatus($mysqli);
    // print "<pre>"; var_dump($aSlaveStatus); print "</pre>";
    closeDatabaseConnection($mysqli);

    ?>

    <table border="1" cellpadding="3" cellspacing="0">
      <tr>
        <th align="left">Variable</th>
        <th align="left">Value</th>
        <th align="center">Status</th>
      </tr>
      <tr>
        <td>Server ID</td>
        <td><?php print $aGlobalVariables['server_id']; ?></td>
        <?php
        if ( intval($aGlobalVariables['server_id']) > 0 ) {
          ?>
          <td align="center"><span style="color:green; font-weight:bolder;">OK</span></td>
          <?php
        }
        else {
          ?>
          <td align="center"><span style="color:red; font-weight:bolder;">ERR</span></td>
          <?php
        }
        ?>
      </tr>
      <tr>
        <td>Binary Log File / Position</td>
        <td><?php print $aMasterStatus['File'] . ' / ' . $aMasterStatus['Position']; ?></td>
        <?php
        if ( strval($aMasterStatus['File']) != '' ) {
          ?>
          <td align="center"><span style="color:green; font-weight:bolder;">OK</span></td>
          <?php
        }
        else {
          ?>
          <td align="center"><span style="color:red; font-weight:bolder;">ERR</span></td>
          <?php
        }
        ?>
      </tr>
      <tr>
        <td>Binary Log Do DB Filter</td>
        <?php
        $filter = 'no filter';
        $state  = 'OK';
        $color  = 'green';
        if ( $aMasterStatus['Binlog_Do_DB'] != '' ) {
          $filter = $aMasterStatus['Binlog_Do_DB'];
          $state  = 'WARN';
          $color  = 'orange';
        }
        ?>
        <td><?php print $filter; ?></td>
        <td align='center' style='color:<?php print $color; ?>; font-weight:bolder;'><?php print $state; ?></td>
      </tr>
      <tr>
        <td>Binary Log Ignorde DB Filter</td>
        <?php
        $filter = 'no filter';
        $state  = 'OK';
        $color  = 'green';
        if ( $aMasterStatus['Binlog_Ignore_DB'] != '' ) {
          $filter = $aMasterStatus['Binlog_Ignore_DB'];
          $state  = 'WARN';
          $color  = 'orange';
        }
        ?>
        <td><?php print $filter; ?></td>
        <td align='center' style='color:<?php print $color; ?>; font-weight:bolder;'><?php print $state; ?></td>
      </tr>
      <tr>
        <td>Binary Log Format</td>
        <td><?php print $aGlobalVariables['binlog_format']; ?></td>
        <?php
        $state  = 'OK';
        $color  = 'green';
        if ( strval($aGlobalVariables['binlog_format']) == 'ROW' ) {
          $state  = 'OK';
          $color  = 'green';
        }
        else {
          $state  = 'WARN';
          $color  = 'orange';
        }
        ?>
        <td align='center' style='color:<?php print $color; ?>; font-weight:bolder;'><?php print $state; ?></td>
        <?php
        ?>
      </tr>
      <tr>
        <td>Sync Binary Log</td>
        <td><?php print $aGlobalVariables['sync_binlog']; ?></td>
        <?php
        // Always warn!
        $state  = 'WARN';
        $color  = 'orange';
        ?>
        <td align='center' style='color:<?php print $color; ?>; font-weight:bolder;'><?php print $state; ?></td>
      </tr>
    </table>
    <?php
  }
}

// ---------------------------------------------------------------------

?>
<h3>Slaves</h3>
<?php

foreach ( $aNodes as $id => $node ) {

  if ( $node['role_id'] == SLAVE ) {

    ?>
    <h4><?php print $node['name']; ?></h4>
    <?php

    list($ret, $mysqli) = openDatabaseConnection($node['database_user'], $node['database_user_password'], $node['hostname'], $node['port']);
    if ( $ret != 0 ) {
      print "<p>" . $mysqli . "</p>\n";
      exit($ret);
    }

    list($ret, $aGlobalVariables) = getAllGlobalVariables($mysqli);
    // print "<pre>"; var_dump($aGlobalVariables); print "</pre>";
    // list($ret, $aMasterStatus) = getShowMasterStatus($mysqli);
    // print "<pre>"; var_dump($aMasterStatus); print "</pre>";
    list($ret, $aSlaveStatus) = getShowSlaveStatus($mysqli);
    // print "<pre>"; var_dump($aSlaveStatus); print "</pre>";
    closeDatabaseConnection($mysqli);

    ?>
    <table border="" cellpadding="3" cellspacing="0">
      <tr><th align="left">Status</th><th align="left">Value</th><th>Status</th></tr>
			<tr><td>Server ID</td><td><?php print $aGlobalVariables['server_id']; ?></td>
				<td align="center">
				<?php
					if ( $aGlobalVariables['server_id'] > 0 ) {
						$state = 'OK';
						$color = 'green';
					}
					else {
						$state = 'ERR';
						$color = 'red';
					}
				?>
				<span style="color:<?php print $color; ?>; font-weight:bolder;"><?php print $state; ?></span>
				</td>
			</tr>
      <?php
      // print "<pre>"; print_r($aSlaveStatus); print "</pre>\n";
      $aExclustionList = array('Connect_Retry', 'Relay_Log_File', 'Relay_Log_Pos', 'Relay_Log_Space', 'Master_SSL_Allowed'
      , 'Master_SSL_CA_File', 'Master_SSL_CA_Path', 'Master_SSL_Cert', 'Master_SSL_Cipher', 'Master_SSL_Key'
      , 'Master_SSL_Verify_Server_Cert');
      foreach ( $aSlaveStatus as $key => $value ) {

        if ( (! in_array($key, $aExclustionList)) && ($value != '') && ($value != '0') && ($value != 'None') ) {

          $color = 'black';
          if ( (($key == 'Slave_IO_Running') && ($value == 'No'))
            || (($key == 'Slave_SQL_Running') && ($value == 'No'))
            || (($key == 'Last_IO_Error') && ($value != ''))
            || (($key == 'Last_IO_Errno') && ($value != ''))
            || (($key == 'Last_SQL_Error') && ($value != ''))
            || (($key == 'Last_SQL_Errno') && ($value != ''))
             ) {
            $color = 'red';
          }
          if ( (($key == 'Seconds_behind_master') && ($value != '0'))
             ) {
            $color = 'orange';
          }

          ?><tr><td><?php print $key; ?></td><td><span style="color:<?php print $color; ?>; font-weight:bolder;"><?php print $value; ?></span></td><td></td></tr><?php
        }
      }
      ?>
    </table>
    <?php
  }  // This server is a Slave
}

closeRepositoryDatabase($dbh);
?>
  